<?php

namespace App\Factory;

use App\Exception;

class MenuFactory {

    private $connection;
    
    public function __construct (\Doctrine\DBAL\Connection $connection) {
        $this->connection = $connection;
    }
    
    /* IDTPBUTTON
    1 - produtos
    2 - grupo de produtos
    3 - mesa
    4 - ambiente
    5 - recebimentos
    6 - grupo de recebimentos
    7 - navegador para direita (grupo de produto)
    8 - navegador para esquerda (grupo de produto)
    9 - navegador para direita (produto)
    A - navegador para esquerda (produto)
    B - grupo de produto combinado
    */
    public function getProducts($CDFILIAL, $CDCAIXA, $NRDIASEMANABLOQ) {
		$sql = "
    		SELECT PR.CDFILIAL, GR.NRCONFTELA, PR.CDIDENTBUTON AS CDPRODUTO, 
    		       PR.DSBUTTON, GR.DSBUTTON AS NMGRUPO, GR.CDGRUPO, GR.IMGGRUPO, 
    		   	   0.00 AS PRICE, PD.IDTIPOCOMPPROD, 
				   NVL(PR.DSENDEIMG, PD.DSENDEIMG) AS IMGPRODUCT, PD.IDIMPPRODUTO, 
    		   	   PD.DSPRODVENDA AS DESCRIPTION
    	    FROM ITMENUCONFTE PR
    	   		JOIN PRODUTO PD
    	    		ON PR.CDIDENTBUTON = PD.CDPRODUTO
    	  	  	JOIN (SELECT IT.CDFILIAL, IT.NRCONFTELA, IT.IDTPBUTTON, IT.NRBUTTON,
							 IT.NRPGCONFTELA, IT.DSBUTTON, IT.NRPGCONFTELA||IT.NRBUTTON AS CDGRUPO, 
							 IT.DSENDEIMG AS IMGGRUPO
    			   	  FROM ITMENUCONFTE IT
    				    WHERE IT.CDFILIAL = :CDFILIAL
    				    AND IT.NRCONFTELA = (SELECT NRCONFTELA 
												FROM CONFTELACAIXA
													WHERE CDFILIAL = :CDFILIAL
													AND CDCAIXA  = :CDCAIXA
													AND DTINIVIGENCIA = (SELECT DTINIVIGENCIA 
														                    FROM (SELECT DTINIVIGENCIA 
        														    				 FROM CONFTELACAIXA 
        												                                 WHERE SYSDATE >= DTINIVIGENCIA 
        																	             AND CDFILIAL = :CDFILIAL
        																	             AND CDCAIXA  = :CDCAIXA
        									ORDER BY DTINIVIGENCIA DESC) WHERE ROWNUM = 1))
    		   			AND IDTPBUTTON = '2') GR
    		    ON PR.CDFILIAL     = GR.CDFILIAL
    		        AND PR.NRCONFTELA   = GR.NRCONFTELA
    		        AND PR.IDTPBUTONAUX = GR.IDTPBUTTON
    		        AND PR.NRBUTTONAUX  = GR.NRBUTTON
    		        AND PR.NRPGCONFTAUX = GR.NRPGCONFTELA
    	";
    	/*
    	 LEFT JOIN ( SELECT CDPRODUTO, CDLOJA, CDFILIAL
                		   FROM PRODBLOQVND
                	   WHERE PRODBLOQVND.CDFILIAL = :CDFILIAL
                	   AND (NRDIASEMANABLOQ = 'T' OR NRDIASEMANABLOQ = :NRDIASEMANABLOQ)) PB
                	     ON PB.CDPRODUTO = PD.CDPRODUTO
                	     AND PB.CDLOJA    = GR.CDLOJA
                	     AND PB.CDFILIAL  = PR.CDFILIAL
    	  	   
    		 WHERE PB.CDPRODUTO IS NULL
		*/
		$params = [
			':CDFILIAL'        => $CDFILIAL,
			':CDCAIXA'         => $CDCAIXA,
			':NRDIASEMANABLOQ' => $NRDIASEMANABLOQ
		];
       
		
		return $this->connection->fetchAll($sql, $params);
    }
    
    public function getGeneralProducts($CDFILIAL, $NRCONFTELA) {
		$sql = "
    		SELECT IT.CDIDENTBUTON AS CDPRODUTO, IT.DSBUTTON,
    		       PR.IDTIPOCOMPPROD, PR.IDIMPPRODUTO, PR.NMPRODUTO
    	      
    	      FROM ITMENUCONFTE IT
    
    	   	  JOIN PRODUTO PR
    	    	ON IT.CDIDENTBUTON = PR.CDPRODUTO
    	    	
    	     WHERE IT.CDFILIAL = :CDFILIAL
    	       AND IT.NRCONFTELA = :NRCONFTELA
    	       AND IT.IDTPBUTTON = '1'
    	       
    	  ORDER BY CDPRODUTO
    	       
    	";
		
		$params = [
			':CDFILIAL'    => $CDFILIAL,
			':NRCONFTELA' => $NRCONFTELA
		];
       
		
		return $this->connection->fetchAll($sql, $params);
    }
    
    public function getBlockedProducts($CDFILIAL) {
        
        $NRDIASEMANABLOQ = date("w") + 1;
        
		$sql = "
    		SELECT DISTINCT CDPRODUTO
              FROM PRODBLOQVND
             WHERE CDFILIAL = :CDFILIAL
               AND (NRDIASEMANABLOQ = :NRDIASEMANABLOQ
                    OR NRDIASEMANABLOQ = 'T')
    	";
		
		$params = [
			':CDFILIAL' => $CDFILIAL,
			':NRDIASEMANABLOQ' => $NRDIASEMANABLOQ
		];
       
		
		return $this->connection->fetchAll($sql, $params);
    }
	
    public function getComboProducts($CDFILIAL, $CDCAIXA, $CDLOJA) {
        $sqlComboProds = "
            SELECT I.NRBUTTON, I.DSBUTTON, I.NRLIMPRODCOM, L.IDTIPCOBRA
              FROM ITMENUCONFTE I
              JOIN LOJA L ON L.CDFILIAL = I.CDFILIAL
             WHERE I.CDFILIAL = :CDFILIAL
               AND L.CDLOJA = :CDLOJA
               AND I.NRCONFTELA IN (SELECT NRCONFTELA
                                   FROM CAIXA
                                  WHERE CDFILIAL = :CDFILIAL
                                    AND CDCAIXA = :CDCAIXA)
               AND I.IDTPBUTTON = 'B'
        ";
        
        $sqlComboChilds = "
            SELECT NVL(I.CDIDENTBUTON, P.CDPRODUTO) AS CDIDENTBUTON,
                   NVL(I.DSBUTTON, P.NMPRODUTO) AS DSOCORR, P.CDARVPROD AS CDOCORR,
                   P.CDARVPROD,  P.CDARVPROD AS CDPRODUTO, P.IDTIPOPROD, P.IDTIPOCOMPPROD,
                   NVL(I.DSBUTTON, P.NMPRODUTO) AS NOME, P.IDIMPPRODUTO, 'COMBO' AS NMGRUPROMOC,
                   P.DSPRODVENDA AS DESCRIPTION
              FROM PRODUTO P LEFT JOIN ITMENUCONFTE I
                                    ON P.CDPRODUTO = I.CDIDENTBUTON
                                   AND I.CDFILIAL = :CDFILIAL
                                   AND I.NRCONFTELA IN (SELECT NRCONFTELA
                                                         FROM CAIXA
                                                        WHERE CDFILIAL = :CDFILIAL
                                                          AND CDCAIXA = :CDCAIXA)
            WHERE P.IDTIPOPROD IS NOT NULL
        ";
        
        $params = [
            ':CDFILIAL' => $CDFILIAL,
            ':CDCAIXA'  => $CDCAIXA,
            ':CDLOJA'   => $CDLOJA
        ];
        
        // Gets the combo product "buttons", which are the containers for the actual combo products.
        $comboProds = $this->connection->fetchAll($sqlComboProds, $params);
        // Gets all the actual combo products. These must be sorted into their respective buttons.
        $comboChilds = $this->connection->fetchAll($sqlComboChilds, $params);

        $result = [];
        
        foreach ($comboProds as $comboProd) {
            
            // This item serves only as a container. This container holds products that are used to build a combination of products. This is why these products are called combo products.
            $comboItem = [
                "DSBUTTON"       => $comboProd['DSBUTTON'], // Button name.
                "NMGRUPO"        => 'PIZZAS', // Combo products don't have a group, so we set a unique name here to identify them by name.
                "CDGRUPO"        => 'X-X', // Combo products don't have a group. so we set a unique code here to identify them by code.
                "IMGGRUPO"       => '',
                "IMGPRODUCT"     => '',
                "PRICE"          => 0, // Combo products don't have a price.
                "IDTIPOCOMPPROD" => 'C', // We use this constant to identify combo products throughout the system.
                "NOIMAGE"        => 'images/noimage.png', // No image.
                "DESCRIPTION"    => null,
                "NRLIMPRODCOM"   => $comboProd['NRLIMPRODCOM'], // Limits how many combinations can be selected.
                "IDTIPCOBRA"     => $comboProd['IDTIPCOBRA'], // This parameter determines how the price will be calculated. C will use the price of the most expensive product. M will use the original price of each product.
                "PROMOPRODS"     => [], // We must keep this array since it is used to identify SmartPromo products.
                "COMBOPRODS"     => [] // This array will hold the actual combo products, populated below.
            ];

            foreach ($comboChilds as $comboChild) {
                if (intval($comboChild['IDTIPOPROD']) == intval($comboProd['NRBUTTON'])) {
                    $comboChild['CDFILIAL'] = $CDFILIAL;
                    $comboChild['CDLOJA']   = $CDLOJA;

                    array_push($comboItem['COMBOPRODS'], $comboChild);
                }
            }
            
            array_push($result, $comboItem);
        }

        return $result;
    }

	public function getObservations($CDFILIAL, $CDLOJA, $NRDIASEMANABLOQ) {
		$sql = "
    		SELECT	OC.CDPRODUTO AS CODIGOOCORRENCIA, PR.CDPRODUTO, GR.CDGRPOCOR,
    			PR.CDOCORR, NVL(OC.DSAPELIDOOBS , OC.DSOCORR) AS DSOCORR, 
    			LJ.CDFILIAL AS FILIAL, OC.IDCONTROLAOBS
    	  
    	  FROM GRUPOCOR GR, PRODOCORRE PR, LOJA LJ, OCORRENCIA OC, 
    	       ( SELECT CDPRODUTO, CDLOJA, CDFILIAL
    			   FROM PRODBLOQVND
    			  WHERE PRODBLOQVND.CDFILIAL = :CDFILIAL
    			    AND CDLOJA = :CDLOJA 
    			    AND (NRDIASEMANABLOQ = 'T' OR NRDIASEMANABLOQ = :NRDIASEMANABLOQ)) PB
    		 
    		 WHERE LJ.CDLOJA    = :CDLOJA
    		   AND LJ.CDFILIAL  = :CDFILIAL
    		   AND GR.CDGRPOCOR = LJ.CDGRPOCORPED
    		   AND PR.CDGRPOCOR = GR.CDGRPOCOR
    		   AND GR.CDGRPOCOR = OC.CDGRPOCOR
    		   AND PR.CDOCORR   = OC.CDOCORR
    		   AND PR.CDPRODUTO = PB.CDPRODUTO(+)
    		   AND PB.CDPRODUTO IS NULL 
    		   AND OC.IDEXIOBSAPPCONS = 'S'
    		ORDER BY PR.CDPRODUTO
    	";
		
		$params = [
			':CDFILIAL'        => $CDFILIAL,
			':CDLOJA'          => $CDLOJA,
			':NRDIASEMANABLOQ' => $NRDIASEMANABLOQ
		];
		
		return $this->connection->fetchAll($sql, $params);
	}
	
	public function getGrupPromo($CDPRODUTO) {
	    $sql = "
    		SELECT G.CDPRODPROMOCAO, G.CDGRUPROMOC, P.NMGRUPROMOC, G.QTPRGRUPPROMOC, G.QTPRGRUPROMIN ,G.NRORDPROMOGRUP
    		FROM GRUPROMOCPROD G 
    			JOIN GRUPROMOC P
    				ON P.CDGRUPROMOC = G.CDGRUPROMOC
    		WHERE G.CDPRODPROMOCAO = :CDPRODUTO
    		ORDER BY G.NRORDPROMOGRUP, G.CDGRUPROMOC
    	";
	    
		$params = [
			':CDPRODUTO' => $CDPRODUTO
		];

		return $this->connection->fetchAll($sql, $params);
	}
	
	public function getProdGrup($CDPRODPROMOCAO, $CDGRUPROMOC, $CDFILIAL, $CDTABEPREC, $CDLOJA, $NRDIASEMANABLOQ, $DTINIVGPREC) {
		$sql = "
    	  SELECT GPP.CDPRODPROMOCAO AS PRODUTO_PAI_PROMO,
    			 PGP.CDGRUPROMOC AS GRUPO_PROMO,
    			 P.NMPRODUTO AS NOME,
    			 NVL(NVL(IT.VRPRECITEM, ITG.VRPRECITEM) ,0) AS PRICE,
    			 PGP.CDPRODUTO, GPM.NMGRUPROMOC,
    			 IT.CDFILIAL,
    			 DPP.IDPERVALORDES AS TIPO,
    			 DPP.VRDESPRODPROMOC AS VRDESC
            
    		FROM PRODGRUPROMOC PGP
    
    		JOIN GRUPROMOCPROD GPP
    		  ON (PGP.CDGRUPROMOC = GPP.CDGRUPROMOC)
    
    		JOIN PRODUTO P
    		  ON (PGP.CDPRODUTO = P.CDPRODUTO)
    
    		LEFT JOIN ITEMPRECO IT
    		  ON (PGP.CDPRODUTO = IT.CDPRODUTO)
              AND (IT.CDPRODUTO = P.CDPRODUTO)
              AND (IT.CDFILIAL = :CDFILIAL)
    		  AND (IT.CDTABEPREC = :CDTABEPREC) 
              AND (IT.DTINIVGPREC = TO_DATE(:DTINIVGPREC, 'DD/MM/YYYY'))
    			 
    		LEFT JOIN ITEMPRECOGER ITG
    		  ON (PGP.CDPRODUTO = ITG.CDPRODUTO) 
              AND (ITG.CDPRODUTO = P.CDPRODUTO)
              AND (ITG.CDTABEPREC = :CDTABEPRECGER) 
              AND (ITG.DTINIVGPREC = TO_DATE(:DTINIVGPRECGER, 'DD/MM/YYYY'))
    
            LEFT JOIN DESGRUPROMOCPR DPP
    		  ON (PGP.CDGRUPROMOC = DPP.CDGRUPROMOC) AND
    			 (PGP.CDPRODUTO = DPP.CDPRODUTO) AND
    			 (GPP.CDPRODPROMOCAO = DPP.CDPRODPROMOCAO)
    
    	    JOIN GRUPROMOC GPM
    	      ON GPM.CDGRUPROMOC = PGP.CDGRUPROMOC
    
    	 LEFT JOIN ( SELECT CDPRODUTO, CDLOJA, CDFILIAL
    				   FROM PRODBLOQVND
    				  WHERE PRODBLOQVND.CDFILIAL = :CDFILIAL
    				    AND (NRDIASEMANABLOQ = 'T' OR NRDIASEMANABLOQ = :NRDIASEMANABLOQ)) PB
    	        ON PB.CDPRODUTO = PGP.CDPRODUTO
    		   AND PB.CDLOJA    = :CDLOJA
    	  	   AND PB.CDFILIAL  = :CDFILIAL
    
    	   WHERE (GPP.CDPRODPROMOCAO = :CDPRODPROMOCAO)
    	     AND (PGP.CDGRUPROMOC = :CDGRUPROMOC) 
    		 AND PB.CDPRODUTO IS NULL
    		 AND P.IDPRODATIVPR = 'S'
    
     	   ORDER BY CDPRODUTO
    	";
		
		$params = [
			':CDPRODPROMOCAO'  => $CDPRODPROMOCAO,
			':CDGRUPROMOC'     => $CDGRUPROMOC,
			':CDFILIAL'        => $CDFILIAL,
			':CDTABEPREC'      => $CDTABEPREC['CDTABEPREC'],
			':CDLOJA'          => $CDLOJA,
			':NRDIASEMANABLOQ' => strval($NRDIASEMANABLOQ),
			':DTINIVGPREC'     => $DTINIVGPREC,
			':DTINIVGPRECGER'  => $CDTABEPREC['DTINIVGPRECGER'],
			':CDTABEPRECGER'    => $CDTABEPREC['CDTABEPRECGER']
		];
		
		return $this->connection->fetchAll($sql, $params);
	}
	
	public function getMenusUpdates() {
		$sql = "
    		SELECT *
              FROM (SELECT TO_CHAR(DTOPERACAOVND, 'DD/MM/YYYY HH24:MI:SS') AS DTOPERACAOVND, DSOPERACAOVND, CDFILLOGOPERVND
                      FROM LOGOPERAVND
                     WHERE NMTABELAVND IN ('ITMENUCONFTE', 'PRODBLOQVND', 'GRUPOCOR',
                                           'PRODOCORRE', 'OCORRENCIA', 'GRUPROMOCPROD',
                                           'GRUPROMOC', 'PRODGRUPROMOC', 'PRODUTO',
                                           'ITEMPRECO', 'DESGRUPROMOCPR', 'TABEVENDGER',
                                           'ITEMPRECOGER', 'FILITABGER', 'TABEPRECGER', 
                                           'ITEMPRECODIAGER')
                  ORDER BY DTOPERACAOVND DESC)
             WHERE ROWNUM <= 3
    	       
    	";
       
		
		return $this->connection->fetchAll($sql);
    }
    
    public function getPricingTables() {
        $sql = "
            SELECT TV.CDTABEPREC, TP.NMTABEPREC, TO_CHAR(TV.DTINIVGPREC, 'DD/MM/YYYY') AS DTINIVGPREC, TO_CHAR(TV.DTFINVGPREC, 'DD/MM/YYYY') AS DTFINVGPREC
              FROM TABEVENDGER TV
              JOIN TABEPRECGER TP
                ON TP.CDTABEPREC = TV.CDTABEPREC
          ORDER BY TV.CDTABEPREC
        ";
        
        return $this->connection->fetchAll($sql);
   } 
}